
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char **argv) {

  char *in, *out, *inp, *outp, *cp1, *cp2, *cbuf, *rep, *nbuf, buf1[512],buf2[512],*src,*dest;
  FILE *fpi, *fpo;
  int i, swaps, i1;
  
  if(argc<2) {
  
    puts(
      "filer {infile} {outfile} -D{DEFINE}={TEXT} -D{DEFINE}={TEXT}..."
      );
     exit(0);
     }
  
  /* setup space for pairs */
  in=malloc(argc*25);
  out=malloc(argc*50);
  
  in[0]=out[0]=0x00;
  swaps=0;
  
  for(i=3;i<argc;i++) {
     cp1=argv[i]+2; /* start of define */
     cp2=strchr(cp1,'=');
     *cp2=0x00;
     cp2++;
     strcat(in,"{");
     strcat(in,cp1);
     strcat(out,cp2);
     /* printf("will replace %s with %s\n",cp1,cp2);*/
     swaps++;
     strcat(in,"}=");
     strcat(out,"=");
  }
  
  /* replace '=' with 0x00 */
  cp1=strchr(in,'=');
  while(cp1!=NULL) {*cp1=0x00;cp1++;cp1=strchr(cp1,'=');}
  cp1=strchr(out,'=');
  while(cp1!=NULL) {*cp1=0x00;cp1++;cp1=strchr(cp1,'=');}
  
  fpi=fopen(argv[1],"ra");
  fpo=fopen(argv[2],"wa");   

  cbuf=fgets(buf1,512,fpi);
  nbuf=buf2;
  while(cbuf!=NULL) {
    cp1=cbuf;
    while((*cp1=='\t' || *cp1==' ') && *cp1!=0x00) cp1++;
    if(*cp1!='#') {  /* ignore lines that begin with a hash */
       
       cp1=in;
       cp2=out;
       src=cbuf;
       dest=nbuf;
       for(i=0;i<swaps;i++) {
           src=cbuf;
           dest=nbuf;
          strcpy(dest,src);
	  rep=strstr(src,cp1);
	  while(rep!=NULL) {
	     i1=(int)rep-(int)src;
	     strncpy(dest,src,i1);
	     dest[i1]=0x00;
	     src+=i1+strlen(cp1);
	     strcat(dest,cp2);
	     dest+=i1+strlen(cp2);	  
	     rep=strstr(src,cp1);
	  }
	  strcpy(dest,src);
          strcpy(cbuf,nbuf);
          cp1+=strlen(cp1)+1;
	  cp2+=strlen(cp2)+1;
       } /* go thought each swap (for) */
    
    fputs(nbuf,fpo);
    
    } /* ignore hash lines */

  cbuf=fgets(buf1,512,fpi);
  }
  
  
  fclose(fpi);
  fclose(fpo);

return 0;
}
