

#include "sssd.h"
#include "internals.h"

/*
   Continues paused audio.
   Does nothing if pauseAudio() has not been called.
*/

void sssd_unpauseAudio( struct sssdaudio* ga )
{
    if( audioValid( ga ) && ga->paused )
    {
        ga->paused = 0;
        UNLOCK_BUFFERS(ga);
    }
}
